From 3cad4c467d130ab30a9abadd24b2683074d998ce Mon Sep 17 00:00:00 2001
From: Dilip Kumar <dilipkumar@localhost.localdomain>
Date: Thu, 10 Jan 2019 12:06:08 +0530
Subject: [PATCH] Undo worker and transaction rollback

Patch provides mechanism for discarding the older undo when they
are no longer relavent.  It also providea a mechanism for rolling
back the effect of the aborted transactiona.  It handles the rollbacks
directly from backends as well as from undo worker for the larger
transaction.

Dilip Kumar, with help from Rafia Sabih, Amit Kapila, Mithun.CY, Thomas Munro and Kuntal Ghosh
---
 src/backend/access/rmgrdesc/Makefile          |   3 +-
 src/backend/access/rmgrdesc/undoactiondesc.c  |  64 +++
 src/backend/access/rmgrdesc/xlogdesc.c        |   4 +-
 src/backend/access/transam/rmgr.c             |   5 +-
 src/backend/access/transam/twophase.c         |  45 +-
 src/backend/access/transam/varsup.c           |  11 +
 src/backend/access/transam/xact.c             | 441 ++++++++++++++++-
 src/backend/access/transam/xlog.c             |  20 +
 src/backend/access/undo/Makefile              |   2 +-
 src/backend/access/undo/undoaction.c          | 688 ++++++++++++++++++++++++++
 src/backend/access/undo/undoactionxlog.c      |  49 ++
 src/backend/access/undo/undodiscard.c         | 447 +++++++++++++++++
 src/backend/access/undo/undoinsert.c          |  52 +-
 src/backend/access/undo/undorecord.c          |   3 +
 src/backend/commands/vacuum.c                 |  10 +
 src/backend/postmaster/Makefile               |   4 +-
 src/backend/postmaster/bgworker.c             |  11 +
 src/backend/postmaster/discardworker.c        | 170 +++++++
 src/backend/postmaster/pgstat.c               |   7 +-
 src/backend/postmaster/postmaster.c           |   7 +
 src/backend/postmaster/undoworker.c           | 664 +++++++++++++++++++++++++
 src/backend/replication/logical/decode.c      |   4 +
 src/backend/storage/ipc/ipci.c                |   6 +
 src/backend/storage/lmgr/lwlocknames.txt      |   2 +
 src/backend/storage/lmgr/proc.c               |   2 +
 src/backend/utils/adt/lockfuncs.c             |   1 +
 src/backend/utils/init/globals.c              |   1 +
 src/backend/utils/misc/guc.c                  |  11 +
 src/backend/utils/misc/pg_controldata.c       |   9 +-
 src/backend/utils/misc/postgresql.conf.sample |   7 +
 src/bin/pg_controldata/pg_controldata.c       |   2 +
 src/bin/pg_resetwal/pg_resetwal.c             |   7 +
 src/bin/pg_rewind/parsexlog.c                 |   2 +-
 src/bin/pg_waldump/rmgrdesc.c                 |   3 +-
 src/include/access/rmgr.h                     |   2 +-
 src/include/access/rmgrlist.h                 |  47 +-
 src/include/access/transam.h                  |   4 +
 src/include/access/twophase.h                 |   2 +-
 src/include/access/undoaction.h               |  28 ++
 src/include/access/undoaction_xlog.h          |  74 +++
 src/include/access/undodiscard.h              |  31 ++
 src/include/access/undoinsert.h               |   2 +
 src/include/access/undorecord.h               |  15 +-
 src/include/access/xact.h                     |   1 +
 src/include/access/xlog.h                     |   3 +
 src/include/access/xlog_internal.h            |   9 +-
 src/include/catalog/pg_control.h              |   7 +
 src/include/miscadmin.h                       |   1 +
 src/include/pgstat.h                          |   3 +
 src/include/postmaster/discardworker.h        |  25 +
 src/include/postmaster/undoloop.h             |  89 ++++
 src/include/postmaster/undoworker.h           |  39 ++
 src/include/storage/lock.h                    |  10 +
 src/include/storage/proc.h                    |   2 +
 54 files changed, 3112 insertions(+), 46 deletions(-)
 create mode 100644 src/backend/access/rmgrdesc/undoactiondesc.c
 create mode 100644 src/backend/access/undo/undoaction.c
 create mode 100644 src/backend/access/undo/undoactionxlog.c
 create mode 100644 src/backend/access/undo/undodiscard.c
 create mode 100644 src/backend/postmaster/discardworker.c
 create mode 100644 src/backend/postmaster/undoworker.c
 create mode 100644 src/include/access/undoaction.h
 create mode 100644 src/include/access/undoaction_xlog.h
 create mode 100644 src/include/access/undodiscard.h
 create mode 100644 src/include/postmaster/discardworker.h
 create mode 100644 src/include/postmaster/undoloop.h
 create mode 100644 src/include/postmaster/undoworker.h

diff --git a/src/backend/access/rmgrdesc/Makefile b/src/backend/access/rmgrdesc/Makefile
index 91ad1ef..640d37f 100644
--- a/src/backend/access/rmgrdesc/Makefile
+++ b/src/backend/access/rmgrdesc/Makefile
@@ -11,6 +11,7 @@ include $(top_builddir)/src/Makefile.global
 OBJS = brindesc.o clogdesc.o committsdesc.o dbasedesc.o genericdesc.o \
 	   gindesc.o gistdesc.o hashdesc.o heapdesc.o logicalmsgdesc.o \
 	   mxactdesc.o nbtdesc.o relmapdesc.o replorigindesc.o seqdesc.o \
-	   smgrdesc.o spgdesc.o standbydesc.o tblspcdesc.o undologdesc.o xactdesc.o xlogdesc.o
+	   smgrdesc.o spgdesc.o standbydesc.o tblspcdesc.o undoactiondesc.o \
+	   undologdesc.o xactdesc.o xlogdesc.o
 
 include $(top_srcdir)/src/backend/common.mk
diff --git a/src/backend/access/rmgrdesc/undoactiondesc.c b/src/backend/access/rmgrdesc/undoactiondesc.c
new file mode 100644
index 0000000..89343b8
--- /dev/null
+++ b/src/backend/access/rmgrdesc/undoactiondesc.c
@@ -0,0 +1,64 @@
+/*-------------------------------------------------------------------------
+ *
+ * undoactiondesc.c
+ *	  rmgr descriptor routines for access/undo/undoactionxlog.c
+ *
+ * Portions Copyright (c) 1996-2017, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ *
+ * IDENTIFICATION
+ *	  src/backend/access/rmgrdesc/undoactiondesc.c
+ *
+ *-------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include "access/undoaction_xlog.h"
+
+void
+undoaction_desc(StringInfo buf, XLogReaderState *record)
+{
+	char	   *rec = XLogRecGetData(record);
+	uint8		info = XLogRecGetInfo(record) & ~XLR_INFO_MASK;
+
+	if (info == XLOG_UNDO_PAGE)
+	{
+		uint8	*flags = (uint8 *) rec;
+
+		appendStringInfo(buf, "page_contains_tpd_slot: %c ",
+						 (*flags & XLU_PAGE_CONTAINS_TPD_SLOT) ? 'T' : 'F');
+		appendStringInfo(buf, "is_page_initialized: %c ",
+						 (*flags & XLU_INIT_PAGE) ? 'T' : 'F');
+		if (*flags & XLU_PAGE_CONTAINS_TPD_SLOT)
+		{
+			xl_undoaction_page *xlrec =
+						(xl_undoaction_page *) ((char *) flags + sizeof(uint8));
+
+			appendStringInfo(buf, "urec_ptr %lu xid %u trans_slot_id %u",
+							 xlrec->urec_ptr, xlrec->xid, xlrec->trans_slot_id);
+		}
+	}
+	else if (info == XLOG_UNDO_APPLY_PROGRESS)
+	{
+		xl_undoapply_progress *xlrec = (xl_undoapply_progress *) rec;
+
+		appendStringInfo(buf, "urec_ptr %lu progress %u",
+						 xlrec->urec_ptr, xlrec->progress);
+	}
+}
+
+const char *
+undoaction_identify(uint8 info)
+{
+	const char *id = NULL;
+
+	switch (info & ~XLR_INFO_MASK)
+	{
+		case XLOG_UNDO_APPLY_PROGRESS:
+			id = "UNDO APPLY PROGRESS";
+			break;
+	}
+
+	return id;
+}
diff --git a/src/backend/access/rmgrdesc/xlogdesc.c b/src/backend/access/rmgrdesc/xlogdesc.c
index 7f73251..2d4c736 100644
--- a/src/backend/access/rmgrdesc/xlogdesc.c
+++ b/src/backend/access/rmgrdesc/xlogdesc.c
@@ -47,7 +47,8 @@ xlog_desc(StringInfo buf, XLogReaderState *record)
 						 "tli %u; prev tli %u; fpw %s; xid %u:%u; oid %u; multi %u; offset %u; "
 						 "oldest xid %u in DB %u; oldest multi %u in DB %u; "
 						 "oldest/newest commit timestamp xid: %u/%u; "
-						 "oldest running xid %u; %s",
+						 "oldest running xid %u; "
+						 "oldest xid having undo %u ; %s",
 						 (uint32) (checkpoint->redo >> 32), (uint32) checkpoint->redo,
 						 checkpoint->ThisTimeLineID,
 						 checkpoint->PrevTimeLineID,
@@ -63,6 +64,7 @@ xlog_desc(StringInfo buf, XLogReaderState *record)
 						 checkpoint->oldestCommitTsXid,
 						 checkpoint->newestCommitTsXid,
 						 checkpoint->oldestActiveXid,
+						 checkpoint->oldestXidHavingUndo,
 						 (info == XLOG_CHECKPOINT_SHUTDOWN) ? "shutdown" : "online");
 	}
 	else if (info == XLOG_NEXTOID)
diff --git a/src/backend/access/transam/rmgr.c b/src/backend/access/transam/rmgr.c
index 8b05374..6238240 100644
--- a/src/backend/access/transam/rmgr.c
+++ b/src/backend/access/transam/rmgr.c
@@ -18,6 +18,7 @@
 #include "access/multixact.h"
 #include "access/nbtxlog.h"
 #include "access/spgxlog.h"
+#include "access/undoaction_xlog.h"
 #include "access/undolog_xlog.h"
 #include "access/xact.h"
 #include "access/xlog_internal.h"
@@ -31,8 +32,8 @@
 #include "utils/relmapper.h"
 
 /* must be kept in sync with RmgrData definition in xlog_internal.h */
-#define PG_RMGR(symname,name,redo,desc,identify,startup,cleanup,mask) \
-	{ name, redo, desc, identify, startup, cleanup, mask },
+#define PG_RMGR(symname,name,redo,desc,identify,startup,cleanup,mask,undo,undo_desc) \
+	{ name, redo, desc, identify, startup, cleanup, mask, undo, undo_desc },
 
 const RmgrData RmgrTable[RM_MAX_ID + 1] = {
 #include "access/rmgrlist.h"
diff --git a/src/backend/access/transam/twophase.c b/src/backend/access/transam/twophase.c
index 9a8a6bb..1e8d7c5 100644
--- a/src/backend/access/transam/twophase.c
+++ b/src/backend/access/transam/twophase.c
@@ -93,6 +93,7 @@
 #include "miscadmin.h"
 #include "pg_trace.h"
 #include "pgstat.h"
+#include "postmaster/undoloop.h"
 #include "replication/origin.h"
 #include "replication/syncrep.h"
 #include "replication/walsender.h"
@@ -915,6 +916,12 @@ typedef struct TwoPhaseFileHeader
 	uint16		gidlen;			/* length of the GID - GID follows the header */
 	XLogRecPtr	origin_lsn;		/* lsn of this record at origin node */
 	TimestampTz origin_timestamp;	/* time of prepare at origin node */
+	/*
+	 * We need the locations of start and end undo record pointers when rollbacks
+	 * are to be performed for prepared transactions using zheap relations.
+	 */
+	UndoRecPtr	start_urec_ptr[UndoPersistenceLevels];
+	UndoRecPtr	end_urec_ptr[UndoPersistenceLevels];
 } TwoPhaseFileHeader;
 
 /*
@@ -989,7 +996,8 @@ save_state_data(const void *data, uint32 len)
  * Initializes data structure and inserts the 2PC file header record.
  */
 void
-StartPrepare(GlobalTransaction gxact)
+StartPrepare(GlobalTransaction gxact, UndoRecPtr *start_urec_ptr,
+			 UndoRecPtr *end_urec_ptr)
 {
 	PGPROC	   *proc = &ProcGlobal->allProcs[gxact->pgprocno];
 	PGXACT	   *pgxact = &ProcGlobal->allPgXact[gxact->pgprocno];
@@ -1027,6 +1035,10 @@ StartPrepare(GlobalTransaction gxact)
 														  &hdr.initfileinval);
 	hdr.gidlen = strlen(gxact->gid) + 1;	/* Include '\0' */
 
+	/* save the start and end undo record pointers */
+	memcpy(hdr.start_urec_ptr, start_urec_ptr, sizeof(hdr.start_urec_ptr));
+	memcpy(hdr.end_urec_ptr, end_urec_ptr, sizeof(hdr.end_urec_ptr));
+
 	save_state_data(&hdr, sizeof(TwoPhaseFileHeader));
 	save_state_data(gxact->gid, hdr.gidlen);
 
@@ -1452,6 +1464,9 @@ FinishPreparedTransaction(const char *gid, bool isCommit)
 	RelFileNode *delrels;
 	int			ndelrels;
 	SharedInvalidationMessage *invalmsgs;
+	int			i;
+	UndoRecPtr start_urec_ptr[UndoPersistenceLevels];
+	UndoRecPtr end_urec_ptr[UndoPersistenceLevels];
 
 	/*
 	 * Validate the GID, and lock the GXACT to ensure that two backends do not
@@ -1489,6 +1504,34 @@ FinishPreparedTransaction(const char *gid, bool isCommit)
 	invalmsgs = (SharedInvalidationMessage *) bufptr;
 	bufptr += MAXALIGN(hdr->ninvalmsgs * sizeof(SharedInvalidationMessage));
 
+	/* save the start and end undo record pointers */
+	memcpy(start_urec_ptr, hdr->start_urec_ptr, sizeof(start_urec_ptr));
+	memcpy(end_urec_ptr, hdr->end_urec_ptr, sizeof(end_urec_ptr));
+
+	/*
+	 * Perform undo actions, if there are undologs for this transaction.
+	 * We need to perform undo actions while we are still in transaction.
+	 * Never push rollbacks of temp tables to undo worker.
+	 */
+	for (i = 0; i < UndoPersistenceLevels; i++)
+	{
+		if (end_urec_ptr[i] != InvalidUndoRecPtr && !isCommit)
+		{
+			bool	result = false;
+			uint64	rollback_size = 0;
+
+			if (i != UNDO_TEMP)
+				rollback_size = end_urec_ptr[i] - start_urec_ptr[i];
+
+			if (rollback_size >= rollback_overflow_size * 1024 * 1024)
+				result = PushRollbackReq(end_urec_ptr[i], start_urec_ptr[i], InvalidOid);
+
+			if (!result)
+				execute_undo_actions(end_urec_ptr[i], start_urec_ptr[i], true,
+									 true, false);
+		}
+	}
+
 	/* compute latestXid among all children */
 	latestXid = TransactionIdLatest(xid, hdr->nsubxacts, children);
 
diff --git a/src/backend/access/transam/varsup.c b/src/backend/access/transam/varsup.c
index fe94fda..95db516 100644
--- a/src/backend/access/transam/varsup.c
+++ b/src/backend/access/transam/varsup.c
@@ -284,10 +284,21 @@ SetTransactionIdLimit(TransactionId oldest_datfrozenxid, Oid oldest_datoid)
 	TransactionId xidStopLimit;
 	TransactionId xidWrapLimit;
 	TransactionId curXid;
+	TransactionId oldestXidHavingUndo;
 
 	Assert(TransactionIdIsNormal(oldest_datfrozenxid));
 
 	/*
+	 * To determine the last safe xid that can be allocated, we need to
+	 * consider oldestXidHavingUndo.  The oldestXidHavingUndo will be only
+	 * valid for zheap storage engine, so it won't impact any other storage
+	 * engine.
+	 */
+	oldestXidHavingUndo = pg_atomic_read_u32(&ProcGlobal->oldestXidHavingUndo);
+	if (TransactionIdIsValid(oldestXidHavingUndo))
+		oldest_datfrozenxid = Min(oldest_datfrozenxid, oldestXidHavingUndo);
+
+	/*
 	 * The place where we actually get into deep trouble is halfway around
 	 * from the oldest potentially-existing XID.  (This calculation is
 	 * probably off by one or two counts, because the special XIDs reduce the
